
# Need to have stock redis server pre-installed.
require 'jssh-snippet-redis'


defaults =
  firstPort: 6379
  shards: 4

module.exports = (config) ->

  for prop, value in defaults
    if not config[prop] then config[prop] = value

  # List of ports on which we will run redis servers.
  ports = [0..config.shards - 1]

  mkdir '-p', '/var/run/redis'
  mkdir '-p', '/var/log/redis'

  # Configuration templates.
  dir =  "#{__dirname}/tpl"
  tpl_conf = cat "#{dir}/redis.conf"
  tpl_init = cat "#{dir}/redis-server.sh"

  rport = new RegExp "__PORT__", "g"
  for port in ports
    tpl_conf.replace(rport, port).to "/etc/redis/redis-#{port}.conf"
    tpl_init.replace(rport, port).to "/etc/init.d/redis-server-#{port}"
    mkdir '-p', "/var/lib/redis-#{port}"
    chown 'redis', 'redis', "/var/lib/redis-#{port}"
    $ "update-rc.d redis-server-#{port} defaults"
    $ "/etc/init.d/redis-server-#{port} start"

